#include <gst/gst.h>
#include <iostream>
#include "WebRTCMain.h"
#include "WebRTCVideo.h"
// #include "soup-server.h"

// struct websocket {
//   GSocket *listener;
//   GSocketAddress *addr;
//   gushort port;

//   SoupServer *server;
//   SoupWebsocketConnection *connection;
// }websocket;

// void onMessage(SoupWebsocketConnection *ws,
//                  SoupWebsocketDataType type,
//                  GBytes *message,
//                  gpointer user_data) {
//     gsize len;
//     const char *content = (const char *)g_bytes_get_data (message, &len);
//     std::cout<< content <<std::endl;
// }

// static void
// onIncommingConnection (SoupServer              *server,
// 					     SoupWebsocketConnection *connection,
// 					     const char              *path,
// 					     SoupClientContext       *client,
// 					     gpointer                 user_data)
// {
// 	struct websocket *websocket = (struct websocket *)user_data;
  
// 	websocket->connection = g_object_ref (connection);
//   std::cout<<__func__<<std::endl;
//   soup_websocket_connection_send_text(websocket->connection,"gholi");
//   g_signal_connect (websocket->connection, "message", G_CALLBACK(onMessage), NULL);
// }

// void setupListener() {
//   GError *error = NULL;

//   websocket.listener = g_socket_new (G_SOCKET_FAMILY_IPV4,
// 				       G_SOCKET_TYPE_STREAM,
// 				       G_SOCKET_PROTOCOL_TCP,
// 				       &error);
//   if(error)
//     std::cerr<< error->message <<std::endl;

//   websocket.addr = g_inet_socket_address_new_from_string ("127.0.0.1", 5050);
//   g_socket_bind (websocket.listener, websocket.addr, TRUE, &error);
//   if(error)
//     std::cerr<< error->message <<std::endl;
//   g_object_unref (websocket.addr);
//   websocket.addr = g_socket_get_local_address (websocket.listener, &error);
//   if(error)
//     std::cerr<< error->message <<std::endl;
//   websocket.port = g_inet_socket_address_get_port (G_INET_SOCKET_ADDRESS (websocket.addr));
//   g_socket_listen (websocket.listener, &error);
// 	if(error)
//     std::cerr<< error->message <<std::endl;
// }

// void setupServer(const char *origin,
// 		   const char **protocols,
// 		   SoupServerWebsocketCallback callback,
// 		   gpointer user_data){
//   GError *error = NULL;

//   // setupListener();
//   websocket.server = soup_server_new(SOUP_SERVER_SERVER_HEADER, "webrtc", NULL);
//   soup_server_add_websocket_extension(websocket.server,SOUP_TYPE_WEBSOCKET_EXTENSION);
//   websocket.addr = g_inet_socket_address_new_from_string ("127.0.0.1", 5050);
//   websocket.port = g_inet_socket_address_get_port (G_INET_SOCKET_ADDRESS (websocket.addr));
//   soup_server_listen_all (websocket.server, websocket.port, SOUP_SERVER_LISTEN_IPV4_ONLY, &error);
// 	g_assert_no_error (error);
//   soup_server_add_websocket_handler (websocket.server, "/",
// 					   origin, (char **) protocols,
// 					   callback, user_data, NULL);
// }

// void makeWebsocket() {
//   setupServer(NULL, NULL, onIncommingConnection,&websocket);
// }

int main(int argc, char *argv[])
{
  gst_init(&argc, &argv);
  gst_debug_set_active(TRUE);
  if (argc < 2){
    WebRTCVideo::fromFile = false;
  }
  char* path = realpath(argv[1], nullptr);
  if (!path)
    WebRTCVideo::fromFile = false;
  else {
    WebRTCVideo::fromFile = true;
    WebRTCVideo::directoryPath = std::string(path);
    std::cout <<"frame dir: "<<  WebRTCVideo::directoryPath << std::endl;
  }
  // // directoryPath =  std::string(path);
  

  std::string url = "ws://112.27.121.65:5050/";
  std::string origin = "localhost";

  WebRTCMain main;
  for (uint8_t i = 0; i < STREAMS; i++)
    main.connectSignallingServer(url, origin,i);
  // main.connectSignallingServer(url, origin);
  // main.startSignallingServer();
  // std::cout <<"main: tid= "<< std::this_thread::get_id() << std::endl;
  // main.startPipeline();
  // makePipeLine();
  // makeWebsocket();

  GMainLoop *loop = g_main_loop_new(NULL, FALSE);
  g_main_loop_run(loop);
  g_main_loop_unref(loop);

  return 0;
}